from __future__ import division
from turtleGUI import TGUI
import time
from movement import doMove
from Map import Map
import numpy.linalg as LA
import Bewegungsverhalten
from Dijkstra import getShortestPath
from numpy import array


class Simulation(object):
    fps = 20
    sim_rate = 100  # sehr relevant fuer Bewegungsverhalten! 30 -> overshot | 100 und hoeher -> Personen landen perfekt im Ziel
    persons = []
    personsToRemove = []
    gui = TGUI(1200, 1200)
    map_ = Map()
    dt_gui = 1000 / fps
    dt_sim = 1000 / sim_rate
    speed = 1
    running = False
    relevant_radius= 100;
    edgeList=[]
    shortestPaths=[]

    def __init__(self):
        pass
    
#    def construct(self, persons, walls, width, height):
#        """
#        erstellt eine simulation. personst sollte liste[numpy.array] sein. walls sollte liste[liste[numpy.array]] sein
#        """
#        pass
        

    def construct(self, persons, walls, width, height):
        """
        erstellt eine simulation. persons sollte liste[] sein. walls sollte liste[liste[numpy.array]] sein
        """
        self.persons = persons
        self.map_ = Map()
        self

    def start(self):
        Bewegungsverhalten.simulationObject = self
        self.running = True
        timer_simulation, timer_gui = 0, 0
        step = min(self.dt_gui, self.dt_sim)
        
        while self.running:
            timer_simulation += step * self.speed
            timer_gui += step
            if timer_simulation >= self.dt_sim:
                timer_simulation -= self.dt_sim
                # do a simulation step
                self.doStep(step)
                # update the gui
            if timer_gui >= self.dt_gui:
                timer_gui-= self.dt_gui
                self.gui.update(self)
            time.sleep(step / 1000)

    def doStep(self, timestep):
        for p in self.persons:
            p.move(Bewegungsverhalten.getMovement(p,timestep,self.getPersonsInRange(p.nearbyPersonThreshold, p.getPosition()),self.map_))
            #p.move(doMove(p, timestep, self.getPersonsInRange(self.relevant_radius, p.pos), self.map.getObstaclesInRange(self.relevant_radius, p.pos)))
        for p in self.personsToRemove:
            if p in self.persons:
                self.persons.remove(p)
            self.personsToRemove.remove(p)

    def stop(self):
        self.running = False

    def addPerson(self, person):
        self.persons += [person]

    def getPersonsInRange(self, r, point):
        persons=[]
        for person in self.persons:
            diff=   point-person.pos
            if LA.norm(diff) < r :
                persons+=[person]
        return persons
